clear all; close all; clc;
date=20170502;
load('data0205.mat');
%cut by electron signal
%cut on signal on 12's detector (zero signal); and 11's detector (DAQ problem) 
cut=(key_value(:,8)>10)&(abs(data(:,11,2))<55)&((data(:,11,2))>0);%&(sum(data(:,:,2)~=0,2));
%  plot(rem(key_value(cut,4),date),data(cut,11,2),'or')
% plot(rem(key_value(:,6),date),key_value(:,4),'*r')
% plot(rem(key_value(cut,6),date),key_value(cut,8),'*r')

position=key_value(:,4)*7.94e-6;
hour=rem(key_value(:,6),date);

diap(5,:)=(hour>151000)&(hour<151600);
diap(4,:)=(hour>151600)&(hour<152200);
diap(3,:)=(hour>152200)&(hour<152800);
diap(2,:)=(hour>152800)&(hour<153400);
diap(1,:)=(hour>153500)&(hour<154100);
diap(6,:)=(hour>154100)&(hour<154700);
diap(7,:)=(hour>154800)&(hour<155400);



fromd=-6;
bkgsh=6;
for detector=1:11
for dd=1:7
cut2=cut&diap(dd,:)';
x=position(cut2)-48.58-3.46/2;
tmpE=key_value(cut2,8);
Es(dd)=mean(tmpE(abs(tmpE-mean(tmpE))<std(tmpE)));
Ess(dd)=std(tmpE(abs(tmpE-mean(tmpE))<std(tmpE)));

y=data(cut2,detector,2)./Es(dd);

fb(dd,detector) = polyfit(x(x<(fromd+bkgsh)),y(x<(fromd+bkgsh)),0);

%[fs, gofs] = fit(x(x>fromd),y(x>fromd),'exp1');
[fs, gofs] = fit(x((x>fromd)&y>fb(dd,detector)),y((x>fromd)&y>fb(dd,detector)),'exp1','Lower',[0 0.015]);
chi(dd,detector) = gofs.adjrsquare;
lamb(dd,detector)=fs.b;
amp(dd,detector)=fs.a;
% figure
% plot(fs,x,y)
tmp1=confint(fs);
tmp2=(tmp1(1:2:3)-tmp1(2:2:4))/4;
Ierrp(dd,detector,:)=tmp2(:);

tmp1=confint(fs);
tmp2=(tmp1(1:2:3)-tmp1(2:2:4))/4;
Ierrp(dd,detector,:)=tmp2(:);


end 
end

dd=5;
cut2=cut&diap(dd,:)';
x=position(cut2)-48.58-3.46/2;
xfits=fromd:1:(-3);
xfitb=(-22):1:fromd;

figure 
hold on
detector=7;
y=data(cut2,detector,2)./mean(key_value(cut2,8))*1e+3;
semilogy(x,y,'^r','linewidth',2)
semilogy(xfits,amp(dd,detector)*exp(xfits*lamb(dd,detector))*1e+3,'r','linewidth',2)
semilogy(xfitb,repmat(fb(dd,detector),size(xfitb))*1e+3,'Color',[0.8 0.8 0.8],'linewidth',2)
set(gca, 'YScale', 'log')
detector=5;
y=data(cut2,detector,2)./mean(key_value(cut2,8))*1e+3;
semilogy(x,y,'>k','linewidth',2)
semilogy(xfits,amp(dd,detector)*exp(xfits*lamb(dd,detector))*1e+3,'k','linewidth',2)
semilogy(xfitb,repmat(fb(dd,detector),size(xfitb))*1e+3,'Color',[0.8 0.8 0.8],'linewidth',2)

detector=9;
y=data(cut2,detector,2)./mean(key_value(cut2,8))*1e+3;
semilogy(x,y,'<b','linewidth',2)
semilogy(xfits,amp(dd,detector)*exp(xfits*lamb(dd,detector))*1e+3,'b','linewidth',2)
semilogy(xfitb,repmat(fb(dd,detector),size(xfitb))*1e+3,'Color',[0.8 0.8 0.8],'linewidth',2)

set(gca,'fontsize',16)
legend('76^o','Signal','Bkgnd','90^o','Signal','Bkgnd', '104^o','Signal','Bkgnd')
xlabel('Position, [mm]')
ylabel('Amplitude, [a.u.]')
grid on 
title('\phi_B=8.09')
% xlim([-22 0])
% ylim([6 21])


Bphase=sort([5.84 5.74 5.64 5.54 5.44 5.94 6.04]);

figure
errorbar(Bphase,Es/1000,Ess/1000,'-*r','linewidth',2)
set(gca,'fontsize',16)
xlabel('\phi_B, [a.u.]')
ylabel('Electron intensity, [a.u.]')
grid on 




figure
chi(chi<0)=0;
[hc hc]=contourf(Bphase(:), 48:7:118, chi',40)
set(hc,'LineStyle','none');
colorbar
set(gca,'fontsize',16)
 ylabel('Angle, [deg.]')
 xlabel('\phi_B, [a.u.]')
title('R^2')

figure
[hc hc]=contourf(Bphase(:), 48:7:118, 2./lamb',40)
set(hc,'LineStyle','none');
colorbar
set(gca,'fontsize',16)
 ylabel('Angle, [deg.]')
 xlabel('\phi_B, [a.u.]')
title('Evanescent wavelength, [mm]')

%3d diap is bad

figure
hold on 
errorbar(Bphase',2./lamb(:,4),2./lamb(:,4).^2.*Ierrp(:,4,2),'-^b','linewidth',2)
errorbar(Bphase',2./lamb(:,7),2./lamb(:,7).^2.*Ierrp(:,7,2),'-*r','linewidth',2)
errorbar(Bphase',2./lamb(:,10),2./lamb(:,10).^2.*Ierrp(:,10,2),'-ok','linewidth',2)
set(gca, 'YScale', 'log')
set(gca,'fontsize',16)
legend('69^o','90^o', '111^o')
xlabel('\phi_B, [a.u.]')
ylabel('Evanescent wavelength, [mm]')
grid on 


figure
hold on
plot(Bphase',amp(:,4),'-^b','linewidth',2)
plot(Bphase',amp(:,7),'-*r','linewidth',2)
plot(Bphase',amp(:,10),'-ok','linewidth',2)

set(gca,'fontsize',16)
legend('69^o','90^o', '111^o')
xlabel('\phi_B, [a.u.]')
ylabel('Amplitude, [a.u.]')
grid on 



figure
[hc hc]=contourf(Bphase(:), 48:7:118, fb',40)
  set(hc,'LineStyle','none');
colorbar
set(gca,'fontsize',16)
 ylabel('Angle, [deg.]')
 xlabel('\phi_B, [a.u.]')
title('Background, [a.u.]')
%  (hf,'-depsc','file.eps')

figure
[hc hc]=contourf(Bphase(:), 48:7:118, amp',40)
  set(hc,'LineStyle','none');
colorbar
set(gca,'fontsize',16)
 ylabel('Angle, [deg.]')
 xlabel('\phi_B, [a.u.]')
title('Amplitude, [a.u.]')
%  (hf,'-depsc','file.eps')




figure
hold on
 
 
gam=44.2/0.511+1;
bet=sqrt(1-1/gam^2);
phi=2/180*pi;
plot(48:7:118,3*(1/bet-cos((48:7:118)/180*pi))*bet*gam/(2*pi)./(sqrt(1+(bet*gam*sin((48:7:118)/180*pi)*sin(phi)).^2)),'m','linewidth',2)
phi=1/180*pi;
plot(48:7:118,3*(1/bet-cos((48:7:118)/180*pi))*bet*gam/(2*pi)./(sqrt(1+(bet*gam*sin((48:7:118)/180*pi)*sin(phi)).^2)),'g','linewidth',2)
phi=0/180*pi;
plot(48:7:118,3*(1/bet-cos((48:7:118)/180*pi))*bet*gam/(2*pi)./(sqrt(1+(bet*gam*sin((48:7:118)/180*pi)*sin(phi)).^2)),'b','linewidth',2)
  
W=1./(Ierrp(:,:,2)).^2;
chilevel=0;
for c=1:11
    LL(c)=sum(lamb((chi(:,c)>chilevel),c).*W((chi(:,c)>chilevel),c))/sum(W((chi(:,c)>chilevel),c));
    LE(c)=sqrt(1/sum(W((chi(:,c)>chilevel),c)));
end
errorbar(48:7:118,2*(LL.^-1),2./(LL.^2).*LE,'-..k','linewidth',2)

 grid on
 set(gca,'fontsize',16)
 xlabel('Angle, [deg.]')
 ylabel('Evanescent wavelength, [mm]')
 legend('\phi=2^o','\phi=1^o','\phi=0^o','data','Location','northwest')
 

 
save analyze.mat
