clear all; close all; clc;
load('data20170502.mat', 'Sig', 'ErrSig', 'motor_pos_mm','Hour','Electron')
for c=1:size(Hour,1)
    HHMM=str2num([Hour(c,1:2) Hour(c,4:5) Hour(c,7:8)]);
    if (~isempty(HHMM))

hour(c)=HHMM;

    end
end
motor_pos_steps=motor_pos_mm/7.94e-6;
% 
 plot(hour(hour~=0), motor_pos_steps(hour~=0),'.r')

% Normalization
% Sig=Sig./repmat(Electron',[1 12]);

 %% Section phase
diap34=(hour>110600)&(hour<111700);
diap36=(hour>111500)&(hour<112300);
diap38=(hour>112400)&(hour<113000);
diap40=(hour>113100)&(hour<113700);
diap42=(hour>113700)&(hour<114300);
diap44=(hour>114300)&(hour<114900);
diap46=(hour>115300)&(hour<115900);
diap48=(hour>140800)&(hour<141400);

figure
hold on
BKG=-Sig(diap34&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap34&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*b','linewidth',2)
BKG=-Sig(diap36&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap36&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*k','linewidth',2)
BKG=-Sig(diap38&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap38&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*r','linewidth',2)
BKG=-Sig(diap40&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap40&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.om','linewidth',2)
BKG=-Sig(diap42&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap42&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.ob','linewidth',2)
BKG=-Sig(diap44&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap44&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.og','linewidth',2)
BKG=-Sig(diap46&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap46&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.or','linewidth',2)
BKG=-Sig(diap48&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap48&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.ob','linewidth',2)
grid on
set(gca,'fontsize',16)
legend('34 MeV','36 MeV','38 MeV','40 MeV','42 MeV','44 MeV','46 MeV','48 MeV')
ylabel('Amplitude, [a.u.]')
xlabel('Angle, [deg.]')
title('SP spectrum as function of phase of the Section')

%% Buncher power 

diap24=(hour>142600)&(hour<143200);
diap22=(hour>143200)&(hour<143800);
diap20=(hour>143800)&(hour<144400);
diap18=(hour>144400)&(hour<145000);
diap16=(hour>145000)&(hour<145600);
diap14=(hour>145600)&(hour<150200);
diap12=(hour>150300)&(hour<150900);

figure
hold on
BKG=-Sig(diap24&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap24&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*b','linewidth',2)
BKG=-Sig(diap22&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap22&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*k','linewidth',2)
BKG=-Sig(diap20&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap20&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*r','linewidth',2)
BKG=-Sig(diap18&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap18&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.om','linewidth',2)
BKG=-Sig(diap16&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap16&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.ob','linewidth',2)
BKG=-Sig(diap14&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap14&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.og','linewidth',2)
BKG=-Sig(diap12&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap12&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.or','linewidth',2)
grid on
set(gca,'fontsize',16)
legend('2.4 V','2.2 V','2.0 V','1.8 V','1.6 V','1.4 V','1.2 V')
ylabel('Amplitude, [a.u.]')
xlabel('Angle, [deg.]')
title('SP spectrum as function of power of the Buncher')

%% Buncher phase p1

diap584=(hour>151000)&(hour<151600);
diap574=(hour>151600)&(hour<152200);
diap564=(hour>152200)&(hour<152800);
diap554=(hour>152800)&(hour<153400);
diap544=(hour>153500)&(hour<154100);
diap594=(hour>154100)&(hour<154700);
diap604=(hour>154800)&(hour<155400);

figure
hold on
BKG=-Sig(diap584&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap584&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*b','linewidth',2)
BKG=-Sig(diap574&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap574&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*k','linewidth',2)
BKG=-Sig(diap564&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap564&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*r','linewidth',2)
BKG=-Sig(diap554&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap554&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.om','linewidth',2)
BKG=-Sig(diap544&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap544&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.ob','linewidth',2)
BKG=-Sig(diap594&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap594&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.og','linewidth',2)
BKG=-Sig(diap604&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap604&(motor_pos_steps==5.9e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.or','linew',2)
grid on
set(gca,'fontsize',16)
legend('5.84','5.74','5.64','5.54','5.44','5.94','6.04')
ylabel('Amplitude, [a.u.]')
xlabel('Angle, [deg.]')
title('SP spectrum as function of phase of the Buncher')




%% Buncher phase p2

diap700=(hour>155500)&(hour<160000);
diap690=(hour>160000)&(hour<160700);
diap680=(hour>160700)&(hour<161300);
diap670=(hour>161300)&(hour<161900);
diap710=(hour>161900)&(hour<162500);
diap720=(hour>162500)&(hour<163100);

figure
hold on
BKG=-Sig(diap700&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap700&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*b','linewidth',2)
BKG=-Sig(diap690&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap690&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*k','linewidth',2)
BKG=-Sig(diap680&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap680&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-*r','linewidth',2)
BKG=-Sig(diap670&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap670&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.om','linewidth',2)
BKG=-Sig(diap710&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap710&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.ob','linewidth',2)
BKG=-Sig(diap720&(motor_pos_steps==4.2e+6),:);
AMP=-Sig(diap720&(motor_pos_steps==5.8e+6),:);
S=AMP(1,:)-BKG(1,:);
plot(48:7:125,S,'-.og','linew',2)
grid on
set(gca,'fontsize',16)
legend('7.0','6.9','6.8','6.7','7.1','7.2')
ylabel('Amplitude, [a.u.]')
xlabel('Angle, [deg.]')
title('SP spectrum as function of phase of the Buncher')

